#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int N = 1001;
int p[N];

struct Edge {
    int a, b, w;
};

bool cmp(Edge a, Edge b) {
    return a.w < b.w;
}

int find(int x) {
    if (p[x] != x)
        p[x] = find(p[x]);
    return p[x];
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<Edge> e(m);
    for (int i = 0; i < m; i++)
        cin >> e[i].a >> e[i].b >> e[i].w;
    sort(e.begin(), e.end(), cmp);
    for (int i = 1; i <= n; i++)
        p[i] = i;
    int cnt = 0, sum = 0;
    for (int i = 0; i < m; i++) {
        int a = find(e[i].a), b = find(e[i].b);
        if (a != b) {
            p[a] = b;
            cnt++;
            sum += e[i].w;
            if (cnt == n - 1)
                break;
        }
    }
    cout << sum << endl;
    return 0;
}
