#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 50005;

struct Edge
{
    int from, to;
    Edge(){}
    Edge(int from, int to)
        :from(from), to(to){}
};

struct DSU
{
    int componentSize[MAXN];
    int parent[MAXN];

    DSU()
    {
        memset(parent, -1, sizeof(parent));
        for (int i = 0; i < MAXN; i++)
            componentSize[i] = 1;
    }

    void Connect(int u, int v)
    {
        if (componentSize[u] > componentSize[v])
            swap(u, v);

        while (parent[u] != -1)
            u = parent[u];

        while (parent[v] != -1)
            v = parent[v];

        parent[u] = v;

        componentSize[v] += componentSize[u];
        componentSize[u] = 0;
    }

    bool isSame(int u, int v)
    {
        while (parent[u] != -1)
        {
            u = parent[u];
        }


        while (parent[v] != -1)
            v = parent[v];

        return u == v;
    }

    int ComponentSize(int u)
    {
        while (parent[u] != -1)
            u = parent[u];

        return componentSize[u];
    }
};

vector <Edge> edges;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int V, E;
    cin >> V >> E;

    DSU *dsu = new DSU();
    for (int i = 0; i < E; i++)
    {
        int u, v, type;
        cin >> u >> v >> type;

        if (type == 0)
        {
            if (!dsu->isSame(u, v))
                dsu->Connect(u, v);
        }

        else
        {
            edges.emplace_back(u, v);
        }
    }

    int ans = 0;

    for (Edge &e:edges)
    {
        if (dsu->isSame(e.from, e.to))
            continue;

        dsu->Connect(e.from, e.to);
        ans++;

    }

    cout << ans << endl;

    return 0;
}
