#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <vector>

typedef long long llong;
const int MAXN = 300 + 10;
const int MAXLOG = 15;
const int INF  = 1e9;

int n, m;
int cnt[MAXLOG][2];
int a[MAXN][MAXN];
int p[MAXN][MAXN];
std::vector <int> v[MAXN][MAXN];

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            p[i][j] = p[i-1][j] ^ p[i][j-1] ^ p[i-1][j-1] ^ a[i][j];
        }
    }

    for (int row = 0 ; row <= n ; ++row)
    {
        for (int col2 = 1 ; col2 <= m ; ++col2)
        {
            for (int col1 = 0 ; col1 < col2 ; ++col1)
            {
                v[col1][col2].push_back(p[row][col1] ^ p[row][col2]);
            }
        }
    }

    llong ans = 0;
    for (int i = 1 ; i <= m ; ++i)
    {
        for (int j = 0 ; j < i ; ++j)
        {
            memset(cnt, 0, sizeof(cnt));
            for (const int &curr : v[j][i])
            {
                for (int k = 0 ; k < MAXLOG ; ++k)
                {
                    ans += cnt[k][1 ^ ((curr >> k) & 1)] * (1LL << k);
                    cnt[k][(curr >> k) & 1]++;
                }
            }
        }
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n >> m;
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            std::cin >> a[i][j];
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}
