#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <vector>

#pragma GCC optimize ("Ofast,unroll_loops")
#pragma GCC target ("sse4")

typedef long long llong;
const short MAXN = 300;
const short MAXLOG = 13;

short n, m;
short cnt[MAXLOG][2];
short a[MAXN][MAXN];
short a2[MAXN][MAXN];
short p[MAXN][MAXN];

void solve()
{
    if (n < m)
    {
        for (short i = 1 ; i <= n ; ++i)
        {
            for (short j = 1 ; j <= m ; ++j)
            {
                a2[j][i] = a[i][j];
            }
        }

        std::swap(n, m);
        for (short i = 1 ; i <= n ; ++i)
        {
            for (short j = 1 ; j <= m ; ++j)
            {
                a[i][j] = a2[i][j];
            }
        }
    }

    for (short i = 1 ; i <= n ; ++i)
    {
        for (short j = 1 ; j <= m ; ++j)
        {
            p[j][i] = p[j][i-1] ^ p[j-1][i] ^ p[j-1][i-1] ^ a[i][j];
        }
    }

    llong ans = 0;
    for (short col1 = 0 ; col1 < m ; ++col1)
    {
        for (short col2 = col1 + 1 ; col2 <= m ; ++col2)
        {
            for (short i = 0 ; i < MAXLOG ; ++i)
            {
                cnt[i][0] = cnt[i][1] = 0;
            }

            for (short row = 0 ; row <= n ; ++row)
            {
                short currNum = p[col1][row] ^ p[col2][row];
                for (int k = 0 ; k < MAXLOG ; ++k)
                {
                    ans += cnt[k][1 ^ ((currNum >> k) & 1)] * (1LL << k);
                    cnt[k][((currNum >> k) & 1)]++;
                }
            }
        }
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n >> m;
    for (short i = 1 ; i <= n ; ++i)
    {
        for (short j = 1 ; j <= m ; ++j)
        {
            std::cin >> a[i][j];
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}
