#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <vector>
#include <bitset>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n, m;
bool vis[MAXN];
std::vector <int> g[MAXN];

void dfs(int node)
{
    vis[node] = true;
    for (const int &i : g[node])
    {
        if (vis[i]) continue;
        dfs(i);
    }
}

void solve()
{
    int ans = -1;
    for (int i = 1 ; i <= n ; ++i)
    {
        if (vis[i]) continue;
        dfs(i);
        ans++;
    }

    std::cout << ans << '\n';
}

void read()
{
    int u, v, c;
    std::cin >> n >> m;
    for (int i = 1 ; i <= m ; ++i)
    {
        std::cin >> u >> v >> c;
        if (c == 0)
        {
            g[u].push_back(v);
            g[v].push_back(u);
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}
