#include <bits/stdc++.h>
using namespace std;
struct node {
    int w, u, v;
    node(int w, int u, int v) {
        this->w = w;
        this->u = u;
        this->v = v;
    }
};
list<node> adj;
class DSU {
public:
    int* parent;
    DSU(int n) {
        parent = new int[n];
        for(int i = 0; i < n; i++) {
            parent[i] = i;
        }
    }

    int find(int i) {
        if(parent[i] == i) {
            return i;
        }
        return parent[i] = find(parent[i]);
    }

    void unite(int a, int b) {
        int s1 = find(a);
        int s2 = find(b);
        if(s1 > s2) {
            parent[s2] = s1;
        } else {
            parent[s1] = s2;
        }

    }

};

bool cmp(node a, node b) {
    return a.w < b.w;
}

int kruskal(int n) {
    adj.sort(cmp);

    int result = 0;
    int edges = 0;
    DSU g(n + 1);

    for(auto i = adj.begin(); edges < n - 1 && i != adj.end(); i++) {
        int w = (*i).w;
        int u = (*i).u;
        int v = (*i).v;

        if(g.find(u) != g.find(v)) {
            edges++;
            result += w;
            //cout << u << " -> " << v << " - " << (w ? "hard" : "easy") << " " << g.find(u) << " " << g.find(v) << "\n";
            g.unite(u, v);
            /*for(int i = 0; i < n; i++) {
                cout << g.find(i + 1) << " ";
            }
            cout << endl;*/
        }
    }

    return result;
}
int main() {
    int n, m;
    cin >> n >> m;

    for(int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        adj.push_back(node(w, u, v));
    }

    cout << kruskal(n);

    return 0;
}
