#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

struct Edge
{
    int p, q, f;
};

bool cmp(Edge p, Edge q)
{
    return p.f < q.f;
}

const int MAXN = 50000 + 5;
const int MAXM = 100000 + 5;
int n, m;
int a[MAXN];

int par[MAXN];
int depth[MAXN];

int getRoot(int p)
{
    while (par[p] != p)
    {
        p = par[p];
    }
    return p;
}

void join(int p, int q)
{
    int ip = getRoot(p);
    int iq = getRoot(q);

    if (depth[ip] > depth[iq])
    {
        par[iq] = ip;
        depth[iq] = depth[iq] + 1;
    }
    else
    {
        par[ip] = iq;
        depth[ip] = depth[ip] + 1;
    }

}

bool query(int p, int q)
{
    return getRoot(p) == getRoot(q);
}

Edge edges[MAXM];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    int ans = 0;

    for (int i = 1; i <= n; i++)
        par[i] = i;

    for (int i = 1; i <= m; i++)
    {
        cin >> edges[i].p >> edges[i].q >> edges[i].f;
    }
    sort(edges + 1, edges + m + 1, cmp);

    for (int i = 1; i <= m; i++)
    {
        int p = edges[i].p;
        int q = edges[i].q;
        int f = edges[i].f;

        if (!query(p, q))
        {
            join(p, q);
            ans += f;
        }
    }

    cout << ans << endl;

    return 0;
}
/**
9 12
1 2 0
2 3 0
4 5 1
5 6 1
4 8 0
8 9 0
1 4 0
4 7 0
2 5 1
5 8 1
3 6 0
6 9 0


-----
1

*/

